package BBUVA;

import java.util.ArrayList;
import java.util.List;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

public class ControladorBD {

    public void persist(Object object) {
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("Java_BBUVA_finalPU");
        EntityManager em = emf.createEntityManager();
        em.getTransaction().begin();
        try {
            em.persist(object);
            em.getTransaction().commit();
        } catch (Exception e) {
            e.printStackTrace();
            em.getTransaction().rollback();
        } finally {
            em.close();
        }
    }

    public void actualizar(Object object) {
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("Java_BBUVA_finalPU");
        EntityManager em = emf.createEntityManager();
        em.getTransaction().begin();
        try {
            em.merge(object);
            em.getTransaction().commit();
        } catch (Exception e) {
            e.printStackTrace();
            em.getTransaction().rollback();
        } finally {
            em.close();
        }
    }

    public void remove(Object object) {
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("Java_BBUVA_finalPU");
        EntityManager em = emf.createEntityManager();
        em.getTransaction().begin();
        try {
            em.remove(em.merge(object));
            em.getTransaction().commit();
        } catch (Exception e) {
            e.printStackTrace();
            em.getTransaction().rollback();
        } finally {
            em.close();
        }
    }

    public static List getDataTitulares() {
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("Java_BBUVA_finalPU");
        return emf.createEntityManager().createQuery("SELECT t FROM Titular t").getResultList();
    }

    public static List getDataEmpleados() {
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("Java_BBUVA_finalPU");
        return emf.createEntityManager().createQuery("SELECT e FROM Empleado e").getResultList();
    }

    public void setUpDB(Sucursal suc) {
        List<Titular> ts = createTitular();
        for(int i=0;i<ts.size();i++) {
            Titular t = ts.get(i);
            this.persist(t);
        }

        List<Empleado> es = createEmpleado();
        for(int i=0;i<es.size();i++) {
            Empleado e = es.get(i);
            this.persist(e);
        }
    }

    private List<Empleado> createEmpleado() {
        List<Empleado> ae = new ArrayList<Empleado>();

        Empleado e1 = new Empleado();
        e1.setNombre("Pepe");
        e1.setClave("123456");
        e1.setNumOperario(1);
        e1.setDirector(true);
        ae.add(e1);

        Empleado e2 = new Empleado();
        e2.setNombre("Juan");
        e2.setClave("654321");
        e2.setNumOperario(2);
        ae.add(e2);

        return ae;
    }

    private List<Titular> createTitular() {
        List<Producto> AP=new ArrayList<Producto>();
        List<Titular> AT=new ArrayList<Titular>();

        Producto p1=new CuentaCorriente();
        Titular t1=new Persona();
        p1.setNumeroProducto("20984002161000015263");
        p1.addTitular(t1);
        AP.add(p1);
        t1.setDocumentacion("50000000A");
        t1.setNombre("Julian Martinez Morillas");
        AT.add(t1);
        t1.addProducto(p1);

        Producto p2=new CuentaCorriente();
        Titular t2=new Persona();
        p2.setNumeroProducto("20984002181000015264");
        p2.addTitular(t2);
        AP.add(p2);
        t2.setDocumentacion("50000001B");
        t2.setNombre("Javier Alvarez Cejudo");
        AT.add(t2);
        t2.addProducto(p2);

        Producto p3=new CuentaCorriente();
        Titular t3=new Persona();
        p3.setNumeroProducto("20984002141000015265");
        p3.addTitular(t3);
        AP.add(p3);
        t3.setDocumentacion("50000002C");
        t3.setNombre("Martin Rivas Nistal");
        AT.add(t3);
        t3.addProducto(p3);

        Producto p4=new CuentaCorriente();
        Titular t4=new Persona();
        p4.setNumeroProducto("20984002131000015266");
        p4.addTitular(t4);
        AP.add(p4);
        t4.setDocumentacion("50000003D");
        t4.setNombre("Alicia Rivas Cano");
        AT.add(t4);
        t4.addProducto(p3);

        Producto p5=new CuentaCorriente();
        Titular t5=new Persona();
        p5.setNumeroProducto("20984002151000015267");
        p5.addTitular(t5);
        AP.add(p5);
        t5.setDocumentacion("50000004E");
        t5.setNombre("Julia Morente Castro");
        AT.add(t5);
        t5.addProducto(p5);

        Producto p6=new CuentaCorriente();
        Titular t6=new Persona();
        p6.setNumeroProducto("20984002181000015268");
        p6.addTitular(t6);
        AP.add(p6);
        t6.setDocumentacion("50000005F");
        t6.setNombre("Antonio Recio Odon");
        AT.add(t6);
        t6.addProducto(p6);

        Producto p7=new CuentaCorriente();
        Titular t7=new Persona();
        p7.setNumeroProducto("20984002191000015269");
        p7.addTitular(t7);
        AP.add(p7);
        t7.setDocumentacion("50000006G");
        t7.setNombre("Luisa Fernandez Ruiz");
        AT.add(t7);
        t7.addProducto(p7);

        Producto p8=new CuentaCorriente();
        Titular t8=new Persona();
        p8.setNumeroProducto("20984002141000015270");
        p8.addTitular(t8);
        AP.add(p8);
        t8.setDocumentacion("50000007H");
        t8.setNombre("Antonio Martin Ares");
        AT.add(t8);
        t8.addProducto(p8);

        Producto p9=new CuentaCorriente();
        Titular t9=new Persona();
        p9.setNumeroProducto("20984002151000015271");
        p9.addTitular(t9);
        AP.add(p9);
        t9.setDocumentacion("50000008I");
        t9.setNombre("Gabriel Mercado Condal");
        AT.add(t9);
        t9.addProducto(p9);

        Producto p10=new CuentaCorriente();
        Titular t10=new Persona();
        p10.setNumeroProducto("20984002181000015272");
        p10.addTitular(t10);
        AP.add(p10);
        t10.setDocumentacion("50000009J");
        t10.setNombre("Pedro Villar Torres");
        AT.add(t10);
        t10.addProducto(p10);

        Producto p11=new CuentaCorriente();
        Titular t11=new Persona();
        p11.setNumeroProducto("20984002171000015273");
        p11.addTitular(t11);
        AP.add(p11);
        t11.setDocumentacion("50000010K");
        t11.setNombre("Maria Castilla Ramos");
        AT.add(t11);
        t11.addProducto(p11);

        Producto p12=new CuentaCorriente();
        Titular t12=new Persona();
        p12.setNumeroProducto("20984002131000015274");
        p12.addTitular(t12);
        AP.add(p12);
        t12.setDocumentacion("50000011L");
        t12.setNombre("Isabel Torres Ruiz");
        AT.add(t12);
        t12.addProducto(p12);

        Producto p13=new CuentaCorriente();
        Titular t13=new Persona();
        p13.setNumeroProducto("20984002181000015275");
        p13.addTitular(t13);
        AP.add(p13);
        t13.setDocumentacion("50000012M");
        t13.setNombre("Ana Castro Cano");
        AT.add(t13);
        t13.addProducto(p13);

        Producto p14=new CuentaCorriente();
        Titular t14=new Persona();
        p14.setNumeroProducto("20984002171000015276");
        p14.addTitular(t14);
        AP.add(p14);
        t14.setDocumentacion("50000013N");
        t14.setNombre("Luis Canseco Roldan");
        AT.add(t14);
        t14.addProducto(p14);

        Producto p15=new CuentaCorriente();
        Titular t15=new Persona();
        p15.setNumeroProducto("20984002181000015277");
        p15.addTitular(t15);
        AP.add(p15);
        t15.setDocumentacion("50000014O");
        t15.setNombre("Olivia Martinez Fernandez");
        AT.add(t15);
        t15.addProducto(p15);

        Producto p16=new CuentaCorriente();
        Titular t16=new Empresa();
        p16.setNumeroProducto("20981001242000024145");
        p16.addTitular(t16);
        AP.add(p16);
        t16.setDocumentacion("34234324h");
        t16.setNombre("Universidad de Huelva");
        AT.add(t16);
        t16.addProducto(p16);

        Producto p17=new CuentaCorriente();
        Titular t17=new Empresa();
        p17.setNumeroProducto("20981003821540005128");
        p17.addTitular(t17);
        AP.add(p17);
        t17.setDocumentacion("34234564h");
        t17.setNombre("TELEFONICA DE ESPANA, S.A.U.");
        AT.add(t17);
        t17.addProducto(p17);

        Producto p18=new CuentaCorriente();
        Titular t18=new Empresa();
        p18.setNumeroProducto("20980002210007125226");
        p18.addTitular(t18);
        AP.add(p18);
        t18.setDocumentacion("34534324h");
        t18.setNombre("Telefónica Moviles");
        AT.add(t18);
        t18.addProducto(p18);

        Producto p19=new CuentaCorriente();
        Titular t19=new Empresa();
        p19.setNumeroProducto("20980002260000564814");
        p19.addTitular(t19);
        AP.add(p19);
        t19.setDocumentacion("34234333u");
        t19.setNombre("Canal Satelite Digital, SL");
        AT.add(t19);
        t19.addProducto(p19);

        Producto p20=new CuentaCorriente();
        Titular t20=new Empresa();
        p20.setNumeroProducto("20980003410000425188");
        p20.addTitular(t20);
        AP.add(p20);
        t20.setDocumentacion("34211324y");
        t20.setNombre("ENDESA ENERGIA XXI, S.L.");
        AT.add(t20);
        t20.addProducto(p20);

        Producto p21=new CuentaCorriente();
        Titular t21=new Empresa();
        p21.setNumeroProducto("20980005620000954125");
        p21.addTitular(t21);
        AP.add(p21);
        t21.setDocumentacion("34774324e");
        t21.setNombre("El Corte Inglés");
        AT.add(t21);
        t21.addProducto(p21);

        return AT;
    }
}